diff --git a/game/client/src/main/java/net/minecraft/client/Minecraft.java b/game/client/src/main/java/net/minecraft/client/Minecraft.java
index e0e7d0029..3bdbb0558 100644
--- a/game/client/src/main/java/net/minecraft/client/Minecraft.java
+++ b/game/client/src/main/java/net/minecraft/client/Minecraft.java
@@ -30,6 +30,7 @@ import net.minecraft.client.gui.error.ScreenConflictWarning;
 import net.minecraft.client.gui.error.ScreenMissingMinecraft;
 import net.minecraft.client.gui.error.ScreenOutOfMemory;
 import net.minecraft.client.gui.options.data.OptionsPages;
+import net.minecraft.client.gui.server.ScreenSelectServer;
 import net.minecraft.client.gui.toasts.GuiElementToastsHud;
 import net.minecraft.client.holiday.Holidays;
 import net.minecraft.client.player.controller.PlayerControllerSP;
@@ -913,8 +914,16 @@ public class Minecraft
         return saveFormat;
     }
 
+    private Screen lastScreen;
     public void displayScreen(@Nullable Screen screen)
     {
+        // Big sir's mouse fix, clearly the legacy lwjgl dependency is fucked in some way, may we hopefully fully replace it one day
+        if (screen == null && lastScreen != null) {
+            Mouse.setGrabbed(false);
+            Mouse.setGrabbed(true);
+        }
+        lastScreen = screen;
+
         if(currentScreen == null && screen != null)
         {
             if(controllerInput != null)
diff --git a/game/client/src/main/java/net/minecraft/client/entity/particle/ParticleDispatcher.java b/game/client/src/main/java/net/minecraft/client/entity/particle/ParticleDispatcher.java
index b5e5a9eb9..a12f4f265 100644
--- a/game/client/src/main/java/net/minecraft/client/entity/particle/ParticleDispatcher.java
+++ b/game/client/src/main/java/net/minecraft/client/entity/particle/ParticleDispatcher.java
@@ -35,38 +35,38 @@ public final class ParticleDispatcher extends Dispatcher<String, ParticleLambda>
         INSTANCE = this;
         Minecraft mc = Minecraft.getMinecraft();
         addDispatch("bubble", (world, x, y, z, motionX, motionY, motionZ, data) -> new ParticleBubble(world, x, y, z, motionX, motionY, motionZ, true));
-        addDispatch("smoke", (world, x, y, z, motionX, motionY, motionZ, data) -> new ParticleSmoke(world, x, y, z, motionX, motionY, motionX, 1.0f, data));
-        addDispatch("note", (world, x, y, z, motionX, motionY, motionZ, data) -> new ParticleNote(world, x, y, z, motionX, motionY, motionX, data));
-        addDispatch("portal", (world, x, y, z, motionX, motionY, motionZ, data) -> new ParticlePortal(world, x, y, z, motionX, motionY, motionX, data));
-        addDispatch("explode", (world, x, y, z, motionX, motionY, motionZ, data) -> new ParticleExplode(world, x, y, z, motionX, motionY, motionX));
-        addDispatch("flame", (world, x, y, z, motionX, motionY, motionZ, data) -> new ParticleFlame(world, x, y, z, motionX, motionY, motionX, ParticleFlame.Type.ORANGE));
-        addDispatch("blueflame", (world, x, y, z, motionX, motionY, motionZ, data) -> new ParticleFlame(world, x, y, z, motionX, motionY, motionX, ParticleFlame.Type.BLUE));
-        addDispatch("soulflame", (world, x, y, z, motionX, motionY, motionZ, data) -> new ParticleFlame(world, x, y, z, motionX, motionY, motionX, ParticleFlame.Type.SOUL));
+        addDispatch("smoke", (world, x, y, z, motionX, motionY, motionZ, data) -> new ParticleSmoke(world, x, y, z, motionX, motionY, motionZ, 1.0f, data));
+        addDispatch("note", (world, x, y, z, motionX, motionY, motionZ, data) -> new ParticleNote(world, x, y, z, motionX, motionY, motionZ, data));
+        addDispatch("portal", (world, x, y, z, motionX, motionY, motionZ, data) -> new ParticlePortal(world, x, y, z, motionX, motionY, motionZ, data));
+        addDispatch("explode", (world, x, y, z, motionX, motionY, motionZ, data) -> new ParticleExplode(world, x, y, z, motionX, motionY, motionZ));
+        addDispatch("flame", (world, x, y, z, motionX, motionY, motionZ, data) -> new ParticleFlame(world, x, y, z, motionX, motionY, motionZ, ParticleFlame.Type.ORANGE));
+        addDispatch("blueflame", (world, x, y, z, motionX, motionY, motionZ, data) -> new ParticleFlame(world, x, y, z, motionX, motionY, motionZ, ParticleFlame.Type.BLUE));
+        addDispatch("soulflame", (world, x, y, z, motionX, motionY, motionZ, data) -> new ParticleFlame(world, x, y, z, motionX, motionY, motionZ, ParticleFlame.Type.SOUL));
         addDispatch("lava", (world, x, y, z, motionX, motionY, motionZ, data) -> new ParticleLava(world, x, y, z));
         addDispatch("footstep", (world, x, y, z, motionX, motionY, motionZ, data) -> new ParticleFootstep(mc.textureManager, world, x, y, z));
-        addDispatch("splash", (world1, d, d1, d2, d3, d4, d5, data) -> new ParticleSplash(world1, d, d1, d2, d3, d4, d5));
-        addDispatch("largesmoke", (world, x, y, z, motionX, motionY, motionZ, data) -> new ParticleSmoke(world, x, y, z, motionX, motionY, motionX, 2.5f, data));
+        addDispatch("splash", (world1, x, y, z, motionX, motionY, motionZ, data) -> new ParticleSplash(world1, x, y, z, motionX, motionY, motionZ));
+        addDispatch("largesmoke", (world, x, y, z, motionX, motionY, motionZ, data) -> new ParticleSmoke(world, x, y, z, motionX, motionY, motionZ, 2.5f, data));
         addDispatch("puffrgb", (world, x, y, z, motionX, motionY, motionZ, data) -> new ParticlePuffRGB(world, x, y, z, (float) motionX, (float) motionY, (float) motionZ, data));
         addDispatch("reddust", (world, x, y, z, motionX, motionY, motionZ, data) -> new ParticleRedstoneDust(world, x, y, z, data));
         addDispatch("item", (world, x, y, z, motionX, motionY, motionZ, data) -> new ParticleItemBreaking(world, x, y, z, Item.itemsList[MathHelper.clamp(data, 0, Item.itemsList.length - 1)]));
         addDispatch("block", (world, x, y, z, motionX, motionY, motionZ, data) -> new ParticleBlockBreaking(world, x, y, z, motionX, motionY, motionZ, Blocks.blocksList[BlockParticleHelper.decodeBlockID(data)], BlockParticleHelper.decodeBlockSide(data), BlockParticleHelper.decodeBlockMeta(data)).init((int) x, (int) y, (int) z));
-        addDispatch("snowshovel", (world, x, y, z, motionX, motionY, motionZ, data) -> new ParticleSnowShovel(world, x, y, z, motionX, motionY, motionX));
-        addDispatch("heart", (world, x, y, z, motionX, motionY, motionZ, data) -> new ParticleHeart(world, x, y, z, motionX, motionY, motionX));
+        addDispatch("snowshovel", (world, x, y, z, motionX, motionY, motionZ, data) -> new ParticleSnowShovel(world, x, y, z, motionX, motionY, motionZ));
+        addDispatch("heart", (world, x, y, z, motionX, motionY, motionZ, data) -> new ParticleHeart(world, x, y, z, motionX, motionY, motionZ));
         addDispatch("slimechunk", (world, x, y, z, motionX, motionY, motionZ, data) -> {
             if (mc.gameSettings.slimeParticles.value) {
                 return new ParticleSlimeChunk(world, x, y, z, Items.SLIMEBALL);
             }
             return null;
         });
-        addDispatch("fireflyGreen", (world, x, y, z, motionX, motionY, motionZ, data) -> new ParticleFirefly(world, x, y, z, motionX, motionY, motionX, MobFireflyCluster.FireflyColor.GREEN.getId()));
-        addDispatch("fireflyBlue", (world, x, y, z, motionX, motionY, motionZ, data) -> new ParticleFirefly(world, x, y, z, motionX, motionY, motionX, MobFireflyCluster.FireflyColor.BLUE.getId()));
-        addDispatch("fireflyOrange", (world, x, y, z, motionX, motionY, motionZ, data) -> new ParticleFirefly(world, x, y, z, motionX, motionY, motionX, MobFireflyCluster.FireflyColor.ORANGE.getId()));
-        addDispatch("fireflyRed", (world, x, y, z, motionX, motionY, motionZ, data) -> new ParticleFirefly(world, x, y, z, motionX, motionY, motionX, MobFireflyCluster.FireflyColor.RED.getId()));
-        addDispatch("arrowtrail", (world, x, y, z, motionX, motionY, motionZ, data) -> new ParticleArrowGolden(world, x, y, z, motionX, motionY, motionX));
+        addDispatch("fireflyGreen", (world, x, y, z, motionX, motionY, motionZ, data) -> new ParticleFirefly(world, x, y, z, motionX, motionY, motionZ, MobFireflyCluster.FireflyColor.GREEN.getId()));
+        addDispatch("fireflyBlue", (world, x, y, z, motionX, motionY, motionZ, data) -> new ParticleFirefly(world, x, y, z, motionX, motionY, motionZ, MobFireflyCluster.FireflyColor.BLUE.getId()));
+        addDispatch("fireflyOrange", (world, x, y, z, motionX, motionY, motionZ, data) -> new ParticleFirefly(world, x, y, z, motionX, motionY, motionZ, MobFireflyCluster.FireflyColor.ORANGE.getId()));
+        addDispatch("fireflyRed", (world, x, y, z, motionX, motionY, motionZ, data) -> new ParticleFirefly(world, x, y, z, motionX, motionY, motionZ, MobFireflyCluster.FireflyColor.RED.getId()));
+        addDispatch("arrowtrail", (world, x, y, z, motionX, motionY, motionZ, data) -> new ParticleArrowGolden(world, x, y, z, motionX, motionY, motionZ));
         addDispatch("fallingleaf", (world, x, y, z, motionX, motionY, motionZ, data) -> {
             int id = world.getBlockId(MathHelper.floor(x), MathHelper.floor(y), MathHelper.floor(z));
             if (id != 0) {
-                return new ParticleLeaf(world, x, y, z, motionX, motionY, motionX).init(MathHelper.floor(x), MathHelper.floor(y), MathHelper.floor(z));
+                return new ParticleLeaf(world, x, y, z, motionX, motionY, motionZ).init(MathHelper.floor(x), MathHelper.floor(y), MathHelper.floor(z));
             }
             return null;
         });
diff --git a/game/client/src/main/java/net/minecraft/client/gui/ScreenConnectFailed.java b/game/client/src/main/java/net/minecraft/client/gui/ScreenConnectFailed.java
index 8c9f15c57..31a9671da 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/ScreenConnectFailed.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/ScreenConnectFailed.java
@@ -1,6 +1,7 @@
 package net.minecraft.client.gui;
 
 import net.minecraft.client.Minecraft;
+import net.minecraft.client.gui.server.ScreenSelectServer;
 import net.minecraft.core.lang.I18n;
 import org.jetbrains.annotations.NotNull;
 
@@ -49,7 +50,7 @@ public class ScreenConnectFailed extends Screen
     {
         if(button.id == 0)
         {
-            mc.displayScreen(new ScreenMainMenu());
+            mc.displayScreen(new ScreenSelectServer(new ScreenMainMenu()));
         }
     }
 
diff --git a/game/client/src/main/java/net/minecraft/client/gui/ScreenConnecting.java b/game/client/src/main/java/net/minecraft/client/gui/ScreenConnecting.java
index bb9cadba5..96294d34a 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/ScreenConnecting.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/ScreenConnecting.java
@@ -2,6 +2,7 @@ package net.minecraft.client.gui;
 
 import com.mojang.logging.LogUtils;
 import net.minecraft.client.Minecraft;
+import net.minecraft.client.gui.server.ScreenSelectServer;
 import net.minecraft.client.net.handler.PacketHandlerClient;
 import net.minecraft.core.lang.I18n;
 import net.minecraft.core.net.packet.PacketPreLogin;
diff --git a/game/client/src/main/java/net/minecraft/client/gui/ScreenMainMenu.java b/game/client/src/main/java/net/minecraft/client/gui/ScreenMainMenu.java
index a72a61e4b..6ee32e0dc 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/ScreenMainMenu.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/ScreenMainMenu.java
@@ -18,9 +18,9 @@ import com.mojang.logging.LogUtils;
 import net.minecraft.client.gui.error.ScreenMissingJCE;
 import net.minecraft.client.gui.hud.HudIngame;
 import net.minecraft.client.gui.hud.HudIngameDoom;
+import net.minecraft.client.gui.server.ScreenSelectServer;
 import net.minecraft.client.holiday.Holidays;
 import net.minecraft.client.render.Lighting;
-import net.minecraft.client.render.block.model.BlockModel;
 import net.minecraft.client.render.block.model.BlockModelDispatcher;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.client.render.tessellator.Tessellator;
@@ -75,7 +75,7 @@ public class ScreenMainMenu extends Screen
 	public ScreenMainMenu() {
 		ScreenPause.photoModeDisabled = false;
 
-        try (InputStream stream = ScreenMainMenu.class.getResourceAsStream("/assets/minecraft/textures/gui/title/splashes.txt")) {
+        try (InputStream stream = Minecraft.getMinecraft().texturePackList.getResourceAsStream("/assets/minecraft/textures/gui/title/splashes.txt")) {
 
             if (stream == null) {
                 LOGGER.error("Could not locate 'splashes.txt'! Does the file exist!?");
diff --git a/game/client/src/main/java/net/minecraft/client/gui/ScreenSignEditor.java b/game/client/src/main/java/net/minecraft/client/gui/ScreenSignEditor.java
index 8e15eaf18..df5ce47a4 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/ScreenSignEditor.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/ScreenSignEditor.java
@@ -139,6 +139,7 @@ public class ScreenSignEditor extends Screen
     @Override
 	public void render(int mx, int my, float partialTick)
     {
+        GL11.glColor4f(1f, 1f, 1f, 1f);
         if (inKeyboard && (mc.gameSettings.forceOnscreenKeyboard.value || mc.inputType == InputType.CONTROLLER) && !(mc.currentScreen instanceof ScreenKeyboard)) {
             if (editLine < entitySign.signText.length) {
                 ScreenKeyboard keyboard = new ScreenKeyboard(this, null,
diff --git a/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponentVehicleHealthBar.java b/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponentVehicleHealthBar.java
index 049f2df6f..61d7b9701 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponentVehicleHealthBar.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponentVehicleHealthBar.java
@@ -95,7 +95,7 @@ public class HudComponentVehicleHealthBar
 
         int health = 11;
         for (int i = 0; i < 10; i++) {
-            int xHeart = x + i * 8;
+            int xHeart = (x + 9 * 8) - i * 8;
             gui.drawGuiIcon(xHeart, y, 9, 9, TextureRegistry.getTexture("minecraft:gui/hud/heart/pig/container"));
             if (i * 2 + 1 < health)
             {
diff --git a/game/client/src/main/java/net/minecraft/client/gui/paged/Page.java b/game/client/src/main/java/net/minecraft/client/gui/paged/Page.java
index a22b93b82..73cd45dd8 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/paged/Page.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/paged/Page.java
@@ -31,6 +31,10 @@ public class Page {
         return this.components;
     }
 
+    public void clearComponents() {
+        this.components.clear();
+    }
+
     public void initComponents(final @NotNull Minecraft mc) {
         for (final @NotNull PageComponent component : this.components) {
             component.init(mc);
@@ -46,7 +50,7 @@ public class Page {
         return height;
     }
 
-    public @NotNull  ItemStack getIcon() {
+    public @NotNull ItemStack getIcon() {
         return this.icon;
     }
 }
diff --git a/game/client/src/main/java/net/minecraft/client/gui/paged/ScreenPaged.java b/game/client/src/main/java/net/minecraft/client/gui/paged/ScreenPaged.java
index cb1cac4ae..a3659c326 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/paged/ScreenPaged.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/paged/ScreenPaged.java
@@ -17,29 +17,32 @@ import static org.lwjgl.opengl.GL11.*;
 
 public class ScreenPaged
     extends Screen {
-    private static final int TOP_SPACING = 24;
-    private static final int BUTTON_SPACING = 4;
-    private static final int SEPARATOR_WIDTH = 8;
-    private static final int PADDING = 8;
-    private static final int PAGE_BUTTON_HEIGHT = 20;
-
-    private final @NotNull String titleTranslationKey;
-    private final @NotNull String @NotNull [] buttonTranslationKeys;
-
-    private float rightScrollAmount = 0.0f;
-    private float leftScrollAmount = 0.0f;
-    private int top, bottom, rightScrollRegionHeight, leftScrollRegionHeight, pageWidth, leftWidth;
-
-    private @Nullable Float oldRightScrollAmount = null;
-    private @Nullable Float oldLeftScrollAmount = null;
-    private @Nullable Integer clickX;
-    private @Nullable Integer clickY;
-    private @NotNull Page selectedPage;
-    private @Nullable PageComponent clickedComponent;
-    private int clickedComponentY;
-    private @Nullable ItemElement renderItem = null;
-
-    private final @NotNull PageRegistry pageRegistry;
+    protected static final int TOP_SPACING = 24;
+    protected static final int BUTTON_SPACING = 4;
+    protected static final int SEPARATOR_WIDTH = 8;
+    protected static final int PADDING = 8;
+    protected static final int PAGE_BUTTON_HEIGHT = 20;
+    protected static final int ENTRY_LIST_Y_OFFSET = 2;
+
+    protected final @NotNull String titleTranslationKey;
+    protected final @NotNull String @NotNull [] buttonTranslationKeys;
+
+    protected float rightScrollAmount = 0.0f;
+    protected float leftScrollAmount = 0.0f;
+    protected int top, bottom, rightScrollRegionHeight, leftScrollRegionHeight, pageWidth, leftWidth;
+
+    protected @Nullable Float oldRightScrollAmount = null;
+    protected @Nullable Float oldLeftScrollAmount = null;
+    protected @Nullable Integer clickX;
+    protected @Nullable Integer clickY;
+    protected @NotNull Page selectedPage;
+    protected @Nullable PageComponent clickedComponent;
+    protected int clickedComponentY;
+    protected @Nullable ItemElement renderItem = null;
+
+    protected final @NotNull PageRegistry pageRegistry;
+
+    public int rightOffset = 0;
 
     public ScreenPaged(
         final @Nullable Screen parent,
@@ -186,9 +189,8 @@ public class ScreenPaged
         return PAGE_BUTTON_HEIGHT * this.pageRegistry.getPages().size();
     }
 
-    @Override
-    public void render(final int mx, final int my, final float renderPartialTicks) {
-        if (mx > this.leftWidth + SEPARATOR_WIDTH + PADDING && mx < this.width) {
+    public void handleScroll(int mx, int my, float partialTick) {
+        if (mx > this.leftWidth + SEPARATOR_WIDTH + PADDING && mx < this.width - rightOffset) {
             if (Keyboard.isKeyDown(Keyboard.KEY_LCONTROL) || Keyboard.isKeyDown(Keyboard.KEY_RCONTROL)) {
                 this.scrollRightPanel(Mouse.getDWheel() / -0.01f);
             } else {
@@ -203,9 +205,14 @@ public class ScreenPaged
             }
             this.onScrollLeftPanel();
         }
+    }
+
+    @Override
+    public void render(final int mx, final int my, final float renderPartialTicks) {
+        handleScroll(mx, my, renderPartialTicks);
 
         this.leftWidth = (int) (this.width * 0.25f);
-        this.pageWidth = this.width - (this.leftWidth + SEPARATOR_WIDTH + (PADDING * 2));
+        this.pageWidth = this.width - (this.leftWidth + SEPARATOR_WIDTH + (PADDING * 2)) - rightOffset;
         final @NotNull I18n i18n = I18n.getInstance();
 
         this.renderBackground();
@@ -214,9 +221,9 @@ public class ScreenPaged
 
         Scissor.enable(0, this.top, this.width, this.bottom - this.top);
         if (my >= this.top && my <= this.bottom) {
-            this.drawPageItems(this.leftWidth + SEPARATOR_WIDTH + PADDING, this.top - (int) this.rightScrollAmount, this.pageWidth - 8, mx, my);
+            this.drawPageItems(this.leftWidth + SEPARATOR_WIDTH + PADDING, this.top - (int) this.rightScrollAmount + ENTRY_LIST_Y_OFFSET, this.pageWidth - 8, mx, my);
         } else {
-            this.drawPageItems(this.leftWidth + SEPARATOR_WIDTH + PADDING, this.top - (int) this.rightScrollAmount, this.pageWidth - 8, -1, -1);
+            this.drawPageItems(this.leftWidth + SEPARATOR_WIDTH + PADDING, this.top - (int) this.rightScrollAmount + ENTRY_LIST_Y_OFFSET, this.pageWidth - 8, -1, -1);
         }
         Scissor.disable();
 
@@ -286,7 +293,7 @@ public class ScreenPaged
 
         glDisable(GL_TEXTURE_2D);
 
-        final int scrollBarX = this.width - 6;
+        final int scrollBarX = this.width - 6 - rightOffset;
 
         int scrollBarHeightPx = (int) (scrollBarHeightPercent * this.rightScrollRegionHeight);
         if (scrollBarHeightPx < 32) {
@@ -375,7 +382,7 @@ public class ScreenPaged
         final int left = this.leftWidth + SEPARATOR_WIDTH + PADDING;
 
         if (mx >= this.leftWidth + SEPARATOR_WIDTH && my >= this.top && my <= this.bottom) {
-            int componentY = this.top - (int) this.rightScrollAmount;
+            int componentY = this.top - (int) this.rightScrollAmount + ENTRY_LIST_Y_OFFSET;
             for (final @NotNull PageComponent component : this.selectedPage.getComponents()) {
                 if (mx >= left && mx <= left + this.pageWidth - PADDING && my >= componentY && my <= componentY + component.getHeight()) {
                     component.onMouseClick(buttonNum, left, componentY, this.pageWidth - PADDING, mx - left, my - componentY);
@@ -394,10 +401,11 @@ public class ScreenPaged
             for (final @NotNull Page page : this.pageRegistry.getPages()) {
                 if (mx >= 0 && mx <= this.leftWidth && my >= pagesListY && my <= pagesListY + PAGE_BUTTON_HEIGHT) {
                     this.rightScrollAmount = 0;
+                    Page lastPage = this.selectedPage;
                     this.selectedPage = page;
                     this.selectedPage.initComponents(this.mc);
                     this.mc.sndManager.playSound("random.click", SoundCategory.GUI_SOUNDS, 1.0F, 1.0F);
-                    this.mc.texturePackList.refreshIfReady();
+                    onPageChanged(lastPage, page);
                     break;
                 }
                 pagesListY += PAGE_BUTTON_HEIGHT;
@@ -408,6 +416,10 @@ public class ScreenPaged
         this.clickY = my;
     }
 
+    public void onPageChanged(@NotNull Page lastPage, @NotNull Page newPage) {
+        this.mc.texturePackList.refreshIfReady();
+    }
+
     @Override
     public void mouseReleased(final int mx, final int my, final int buttonNum) {
         super.mouseReleased(mx, my, buttonNum);
@@ -460,7 +472,7 @@ public class ScreenPaged
         }
     }
 
-    private void overlayBackground(final int minX, final int maxX, final int minY, final int maxY) {
+    protected void overlayBackground(final int minX, final int maxX, final int minY, final int maxY) {
         if (this.mc.currentWorld == null) {
             final @NotNull Tessellator tessellator = Tessellator.instance;
             this.mc.textureManager.loadTexture("/assets/minecraft/textures/gui/background.png").bind();
diff --git a/game/client/src/main/java/net/minecraft/client/gui/popup/PopupBuilder.java b/game/client/src/main/java/net/minecraft/client/gui/popup/PopupBuilder.java
index bacf4c74e..946de0f74 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/popup/PopupBuilder.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/popup/PopupBuilder.java
@@ -152,6 +152,13 @@ public class PopupBuilder {
         return this;
     }
 
+    public @NotNull PopupBuilder withSwitch(final @NotNull String key, final boolean defaultState, final @NotNull String onTextTranslationKey, final @NotNull String offTextTranslationKey) {;
+        final PopupComponent component = new SwitchComponent(this.width - (HORIZONTAL_MARGIN * 2), defaultState, I18n.getInstance().translateKey(onTextTranslationKey), I18n.getInstance().translateKey(offTextTranslationKey));
+        this.components.add(component);
+        this.componentKeyMap.put(component, key);
+        return this;
+    }
+
     public @NotNull PopupBuilder withBackgroundColor(final int color, final int color2) {
         this.backgroundColor = IntIntPair.of(color, color2);
         return this;
diff --git a/game/client/src/main/java/net/minecraft/client/gui/popup/SwitchComponent.java b/game/client/src/main/java/net/minecraft/client/gui/popup/SwitchComponent.java
new file mode 100644
index 000000000..8d5e9ec26
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/gui/popup/SwitchComponent.java
@@ -0,0 +1,40 @@
+package net.minecraft.client.gui.popup;
+
+import net.minecraft.client.Minecraft;
+import net.minecraft.client.gui.SwitchElement;
+import net.minecraft.core.sound.SoundCategory;
+import org.jetbrains.annotations.NotNull;
+
+public class SwitchComponent extends InteractivePopupComponent<Boolean> {
+    private final @NotNull Minecraft minecraft = Minecraft.getMinecraft();
+    public final SwitchElement switchElement;
+    public SwitchComponent(int width, boolean defaultState, String onText, String offText) {
+        super(width);
+        this.switchElement = new SwitchElement(0, 0, 0, width, getHeight(), defaultState, onText, offText);
+    }
+
+    @Override
+    public @NotNull Boolean getOutput() {
+        return this.switchElement.isOn();
+    }
+
+    @Override
+    public int getHeight() {
+        return 20;
+    }
+
+    @Override
+    public void render(int x, int y, int mouseX, int mouseY) {
+        this.switchElement.xPosition = x;
+        this.switchElement.yPosition = y;
+        this.switchElement.drawButton(this.minecraft, mouseX, mouseY);
+    }
+
+    @Override
+    public void onClick(final int x, final int y, final int button) {
+        if (button == 0 && this.switchElement.mouseClicked(minecraft, x, y)) {
+            this.switchElement.setOn(!this.switchElement.isOn());
+            this.minecraft.sndManager.playSound("random.click", SoundCategory.GUI_SOUNDS, 1.0F, 1.0F);
+        }
+    }
+}
